// Test.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

#include <Ice/Application.h>
#include <IceUtil/Thread.h>

class Thrd : public IceUtil::Thread
{
	class IceObj : public Ice::Application
	{
		Ice::ObjectAdapterPtr m_oa;

		virtual int run(int, char*[])
		{
			m_oa = communicator()->createObjectAdapter("test");
			m_oa->activate();

			communicator()->waitForShutdown();

			return 0;
		}
	public:
		void Shutdown()
		{
			communicator()->shutdown();
		}
	};

	virtual void run()
	{
		char *argv[]={"test1", "test2"};
		IceObj app;
		m_p = &app;
		app.main(1, argv, "Ice.config");
	}
	IceObj *m_p;
public:
	void Shutdown(){m_p->Shutdown();}
};

int main(int argc, char* argv[])
{
	Thrd app;
	app.start();
	::Sleep(10000);
	app.Shutdown();
	::Sleep(10000);
	return 0;
}

